//#############################################################################
//    File:    binarySearchTree.cpp
//    Author:  Yan Xu
//    Date:    02/07/03(First verstion)
//    Course:  IE 171, Lab 5
//    Purpose: This is definition file for a binary tree.
//#############################################################################

#include "binarySearchTree.hpp"

/*===========================================================================*/
// Counts the depth of the subtree rooted at p
/*===========================================================================*/

int BinarySearchTree::getDepth_(BinaryNode* p) const
{
   if (p == 0){
      return 0;
   }
   
   int leftHeight = getDepth_(p->getLeft());
   int rightHeight = getDepth_(p->getRight());
 
   if(p==root_)
      return(leftHeight>rightHeight?leftHeight:rightHeight);
   else
      return(leftHeight>rightHeight?leftHeight+1:rightHeight+1);    
   
}

/*===========================================================================*/
// Computes the average depth of the subtree rooted at p
/*===========================================================================*/

void  BinarySearchTree::getTotalDepth_(BinaryNode* p, int& total) const
{
   if (p == 0)
      return;

   if(p == root_){                 // Root has no parent 
      p->setDepth(0);              // Preorder, not inorder !
   }else{
      p->setDepth(p->getParent()->getDepth() + 1);  
   }
   
   total += p->getDepth();
   
   getTotalDepth_( p->getLeft(), total);
   getTotalDepth_( p->getRight(), total);
}

/*===========================================================================*/
/*===========================================================================*/
