//#############################################################################
//    File:    main.cpp
//    Author:  Yan Xu
//    Date:    02/07/03(First verstion)
//    Course:  IE 171, Lab 5
//    Purpose: This file is to test the functions of a binary tree.
//    Input:   num of element to be generated (argv[1])
//    Output:  A file of tree depths and average depths
//#############################################################################

#include <iostream>
#include <fstream>
#include <ctime>
#include "binarySearchTree.hpp"

using namespace std;

//#############################################################################

int main(int argc, char* argv[])
{
   
   int   i, j;
   const int num        = atoi(argv[1]);          // Num of elements
   const int iteration  = 100;                    // Repeat times
   KEY*  element        = new KEY [num];
   double* aveDepth     = new double [iteration]; // Use to store average depth
   int* tDepth          = new int [iteration];    // Use to store tree depth
   
   //==========================================================================
   // initialize random generator.
   srand ( time(0) ); 
   
   //==========================================================================
   //----- First Part
   //==========================================================================
   
   for (j = 0; j < iteration; ++j) {            // Repeat 100 times
      
      // Generate num random ints in [0, 100000]
      for (i = 0; i < num; ++i) {
	 element[i] = static_cast<int>( (double(rand())/RAND_MAX) * 100000);
      }
      
      // Declare and build a binary search tree
      BinarySearchTree myBT;
      myBT.buildTree(element, num);
      
      // Get the tree depth
      tDepth[j] = myBT.getDepth();
      
      // Get the average depth of each node in the tree.
      aveDepth[j] = myBT.getAverageDepth();
   }
   
   //==========================================================================
   // Output the solution to result.txt file

   ofstream of("result.txt");
   for(i = 0; i < iteration; ++i) 
      of << tDepth[i] << ',' << aveDepth[i] << endl; 
   //==========================================================================

  return 0;
}
